# TODO(alexey): Make a slot for object.function parameters

# TODO(alexey): Possibly add an Initialize method and then a slot deparse(substitute(object.function))
setClass("MesOp",
              representation(space = "vector",
                             measure = "vector",
                             object.function = "function",
                             gradient.function = "function",

                             # parameters for the Object and Gradient functions
                             dots = "list",

                             # parameters of the numerical method
                             file.name = "character",
                             minim = "logical",
                             smallest.step.size = "numeric",
                             step.algo = "numeric",
                             symmetrical.distribution = "logical",
                             tolerance.measure = "numeric",
                             tolerance.gradient = "numeric",
                             uni = "logical",

                             # visual parameters
                             details = "logical",
                             visualize = "logical",

                             # internals
                             alpha = "numeric",
                             base = "numeric",
                             last.fval = "numeric",
                             gradient = "vector",
                             optim = "logical",
                             step.size = "numeric",
                             steps.done = "integer",
                             too.small.step.size = "logical"),
         
              prototype = prototype(space = NULL,
                                    measure = NULL,
                                    object.function = NULL,
                                    gradient.function = NULL,
                                    dots = NULL,

                                    alpha = runif(1, 0 , 1),
                                    base = 0.5,
                                    details = FALSE,
                                    file.name = NA_character_,
                                    last.fval = NA_real_,
                                    gradient = vector(mode = "numeric", length = 0),
                                    minim = TRUE,
                                    optim = FALSE,
                                    smallest.step.size = as.double(10^(-6)),
                                    step.algo = as.integer(0),
                                    step.size = NA_real_,
                                    steps.done = as.integer(0),
                                    symmetrical.distribution = FALSE,
                                    tolerance.measure = as.double(10^{-6}),
                                    tolerance.gradient = as.double(10^{-6}),
                                    too.small.step.size = FALSE,
                                    uni = FALSE,
                                    visualize = FALSE),
                                    
              validity = function(object){
                           cat("Validating\n")
                           # space & measure
                           if (!is.matrix(object@space)){
                             if (length(object@space) != length(object@measure)) stop ("the vector's of space and measure should be of the same length")
                           }
                           else{
                             if (length(object@measure) != length(object@space[, 1])) stop ("the vector's of space and measure should be of the same length")
                           }
                           #alpha
                           if ((object@alpha <= 0) || (object@alpha >= 1)) stop("'alpha' should be in (0,1)")
                           #base
                           if ((object@base <= 0) || (object@base >= 1)) stop("'base' should be in (0,1)")
                           # number.of.steps
                           if (object@steps.done < 0) stop("'steps.done' should be non-negative")
                           # smallest.step.size
                           if (object@smallest.step.size < 0) stop("smallest.step.size should be positive")
                           # step.algo
                           if ((object@step.algo != 0) && (object@step.algo != 1)) stop("there is no such step.algo", object@step.algo)
                           # step.size
                           if (!is.na(object@step.size) && (object@step.size < 0)) stop("'step.size' should be non-negative")
                           # tolerance.measure
                           if ((object@tolerance.measure < 0) || (object@tolerance.measure > 1)) stop("tolerance should be in [0, 1]")
                           # tolerance.gradient
                           if ((object@tolerance.gradient < 0) || (object@tolerance.gradient > 1)) stop("tolerance should be in [0, 1]")
                         })
